#include <iostream>

using namespace std;
bool moguce(int brojevia,int brojevib, int brojevio,int brojeviab,int a,int b,int o, int ab)
{
    if (brojevio < o)
        return false;
    else
        {
            brojevio = brojevio-o;
            if (brojevia<a)
            {
                if (brojevia+brojevio >= a)
                {
                    brojevio = brojevio+brojevia-a;
                    brojevia = 0;
                    if (brojevib<b)
                    {
                        if (brojevib+brojevio >=b)
                        {
                            brojevio = brojevio+brojevib-b;
                            brojevib = 0;
                            if (brojeviab<ab)
                            {
                                if (brojevio+brojeviab>=ab)
                                {
                                    return true;
                                }
                                else
                                    return false;
                            }
                        }
                        else
                            return false;

                    }
                    else
                    {
                        brojevib = brojevib-b;
                        if (brojeviab<ab)
                        {
                            if (brojeviab+brojevib + brojevio >=ab)
                                return true;
                            else
                                return false;
                        }
                        else
                            return true;

                    }


                }
                else
                    return false;
            }
            else
            {
                brojevia = brojevia-a;
                if (brojevib<b)
                {
                    if (brojevib+brojevio >= b)
                    {
                        brojevio = brojevio+brojevib-b;
                        brojevib = 0;
                        if (brojeviab<ab)
                        {
                            if (brojeviab+brojevia+brojevio >=ab)
                                return true;
                            else
                                return false;
                        }
                        else
                        {
                            return true;
                        }
                    }
                    else
                        return false;

                }
                else
                {
                    brojevib = brojevib-b;
                    if (brojeviab<ab)
                    {
                        if (brojeviab+brojevia+brojevib+brojevio >= ab)
                            return true;
                        else
                            return false;
                    }
                    else
                        return true;
                }
            }


        }
}
int main()
{
    int n, brojo, broja, brojb, brojab, potrebnezao = 0,potrebnezaa = 0,potrebnezab = 0,potrebnezaab = 0, proslibrojo, pomocnaa, pomocnab, pomocnao;
    cin >> n;
    cin >> brojo>>broja>>brojb>>brojab;
    pomocnaa = broja;
    pomocnab = brojb;
    string krvnegrupe[n];
    int brojkrvnegrupe[n];
    for (int i = 0; i<n; i++)
    {
        cin >> krvnegrupe[i]>>brojkrvnegrupe[i];
        if (krvnegrupe[i]== "O")
            {
                potrebnezao += brojkrvnegrupe[i];
            }
        else if (krvnegrupe[i]== "A")
            {
                potrebnezaa += brojkrvnegrupe[i];
            }
        else if (krvnegrupe[i]== "B")
            {
                potrebnezab += brojkrvnegrupe[i];
            }
        else if(krvnegrupe[i]=="AB")
            {
                potrebnezaab += brojkrvnegrupe[i];
            }
    }
    pomocnao = brojo-potrebnezao;
    if (moguce(broja,brojb,brojo,brojab,potrebnezaa,potrebnezab,potrebnezao,potrebnezaab))
    {
        cout << "moguce"<<endl;

        for (int k = 0; k<n; k++)
        {
            if (krvnegrupe[k]=="A")
            {
                if (broja >= brojkrvnegrupe[k])
                {
                    broja = broja-brojkrvnegrupe[k];
                    cout << "0 "<< brojkrvnegrupe[k]<<" 0"<<" 0"<<endl;
                }

                else
                {
                    proslibrojo = brojo;
                    brojo = broja+brojo-brojkrvnegrupe[k];
                    cout << proslibrojo-brojo<<" " << broja << " 0" << " 0"<<endl;
                    broja = 0;
                }

            }
            else if (krvnegrupe[k]== "B")
            {
                if (brojb >= brojkrvnegrupe[k])
                {
                    brojb = brojb-brojkrvnegrupe[k];
                    cout << "0"<< " 0 "<<brojkrvnegrupe[k]<<" 0"<<endl;
                }

                else
                {
                    proslibrojo = brojo;
                    brojo = brojb+brojo-brojkrvnegrupe[k];
                    cout << proslibrojo-brojo << " 0 " << brojb << " 0"<<endl;
                    brojb = 0;
                }
            }
            else if(krvnegrupe[k]=="O")
            {
                proslibrojo = brojo;
                brojo = brojo - brojkrvnegrupe[k];
                cout << proslibrojo-brojo<<" 0"<<" 0"<<" 0"<<endl;
            }
            else if (krvnegrupe[k]=="AB")
            {
                    pomocnao = brojo-potrebnezao;
                    if (brojab<brojkrvnegrupe[k])
                    {

                        if (pomocnaa >= potrebnezaa)
                        {
                            pomocnaa = pomocnaa-potrebnezaa;
                            if (brojab+pomocnaa >= brojkrvnegrupe[k])
                            {

                                cout << "0 " <<brojkrvnegrupe[k]-brojab<<" 0 "<<brojab<<endl;
                                pomocnaa = pomocnaa+brojab-brojkrvnegrupe[k];
                                brojab = 0;
                            }
                            else
                            {
                                if (pomocnab >= potrebnezab)
                                {
                                    pomocnab = pomocnab-potrebnezab;
                                    if (pomocnab+pomocnaa+brojab >= brojkrvnegrupe[k])
                                    {
                                        cout << "0 " <<pomocnaa<<" "<<brojkrvnegrupe[k]-brojab-pomocnaa<<" "<<brojab<<endl;
                                        pomocnab = pomocnab+pomocnaa+brojab-brojkrvnegrupe[k];
                                        brojab = 0;
                                        pomocnaa = 0;

                                    }
                                    else
                                    {
                                        cout << brojkrvnegrupe[k]-pomocnaa-pomocnab-brojab <<" "<<pomocnaa<<" "<<pomocnab<<" "<<brojab<<endl;
                                        pomocnao = pomocnao+pomocnaa+pomocnab+brojab-brojkrvnegrupe[k];
                                        brojab = 0;
                                        pomocnaa = 0;
                                        pomocnab = 0;
                                    }
                                }
                                else
                                {
                                    pomocnao = pomocnao+pomocnab-potrebnezab;
                                    cout << brojkrvnegrupe[k]-pomocnaa-brojab << " "<<pomocnaa << " 0 "<<brojab<<endl;
                                    pomocnao = pomocnao - brojkrvnegrupe[k] + pomocnaa+brojab;
                                    pomocnaa = 0;
                                    brojab = 0;

                                }
                            }

                        }
                        else
                        {

                            pomocnao = pomocnao + pomocnaa-potrebnezaa;
                            pomocnaa = 0;
                            if (pomocnab >= potrebnezab)
                            {
                                pomocnab = pomocnab - potrebnezab;
                                if (pomocnab+brojab >= brojkrvnegrupe[k])
                                {
                                    cout << "0"<<" 0 "<<brojkrvnegrupe[k]-brojab <<" "<<brojab<<endl;
                                    pomocnab = pomocnab+brojab-brojkrvnegrupe[k];
                                    brojab = 0;
                                }
                                else
                                {

                                    cout << brojkrvnegrupe[k]-brojab-pomocnab<<" 0 "<<pomocnab<<" "<<brojab<<endl;
                                    pomocnao = pomocnao+pomocnab+brojab-potrebnezaab;
                                    brojab = 0;
                                    pomocnab = 0;
                                }
                            }
                            else
                            {
                                pomocnao = pomocnao + pomocnab-brojkrvnegrupe[k];
                                cout << brojkrvnegrupe[k]-brojab<< " 0 "<< "0 "<<brojab<<endl;
                                pomocnao = pomocnao+brojab - brojkrvnegrupe[k];
                                brojab = 0;
                            }
                        }
                    }
                    else
                    {
                        cout << "0 "<<"0 "<<"0 "<<brojkrvnegrupe[k]<<endl;
                        brojab = brojab-brojkrvnegrupe[k];
                    }
                }
            }


        }
        else
            cout << "nemoguce"<<endl;
    }